config/routes.rb
Rails.application.routes.draw do

  root 'posts#index'

  devise_for :users, controllers: { omniauth_callbacks: 'callbacks' } 

  resources :users, only: [:show, :index]

  resources :posts

  resources :comments

  resources :likes

  resources :friendships

  get :pending_requests, to: 'friendships#pending'
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception

  before_action :configure_permitted_parameters, if: :devise_controller?

  protected

  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up) { |u| u.permit(:name, :email, :password, :password_confirmation) }

    devise_parameter_sanitizer.permit(:account_update) { |u| u.permit(:name, :email, :password, :current_password) }
  end
end

app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

app/views/application/_comment_icon.html.erb
<?xml version='1.0' encoding='utf-8'?>
<svg class="svg-comment" version="1.1" xmlns="http://www.w3.org/2000/svg" viewbox="0 0 129 129" xmlns:xlink="http://www.w3.org/1999/xlink" enable-background="new 0 0 129 129">
  <g>
    <g>
      <path d="m35,49.5h59c2.3,0 4.1-1.8 4.1-4.1s-1.8-4.1-4.1-4.1h-59c-2.3,0-4.1,1.8-4.1,4.1s1.8,4.1 4.1,4.1z"/>
      <path d="m35,69.3h59c2.3,0 4.1-1.8 4.1-4.1 0-2.3-1.8-4.1-4.1-4.1h-59c-2.3,0-4.1,1.8-4.1,4.1 0,2.3 1.8,4.1 4.1,4.1z"/>
      <path
        d="m10.5,95.8h13.2v13.5c0,1.6 0.9,3 2.3,3.7 0.6,0.3 1.2,0.4 1.8,0.4 0.9,0 1.8-0.3 2.5-0.8l22-16.7h66.2c2.3,0 4.1-1.8 4.1-4.1v-72.9c0-2.3-1.8-4.1-4.1-4.1h-108c-2.3,0-4.1,1.8-4.1,4.1v72.8c0,2.3 1.9,4.1 4.1,4.1zm4.1-72.8h99.7v64.6h-63.4c-0.9,0-1.8,0.3-2.5,0.8l-16.5,12.6v-9.3c0-2.3-1.8-4.1-4.1-4.1h-13.2v-64.6z"/>
    </g>
  </g>
</svg>

app/views/application/_delete_icon.html.erb
<svg class="svg-delete" xmlns="http://www.w3.org/2000/svg" viewbox="0 0 24 24">
  <defs>
    <style>
      .a {
        fill: none;
        stroke: #000;
        stroke-linecap: round;
        stroke-linejoin: round;
      }
    </style>
  </defs>
  <title>delete</title><line class="a" x1="0.5" y1="6.507" x2="23.5" y2="6.507"/><path class="a" d="M20.5,6.5v15a2,2,0,0,1-2,2H5.5a2,2,0,0,1-2-2V6.5"/><path class="a" d="M2.5,6.5v-1a2,2,0,0,1,2-2h15a2,2,0,0,1,2,2v1"/><path class="a" d="M9,3.5a3,3,0,0,1,6,0"/><line class="a" x1="12" y1="10" x2="12" y2="19.5"/><line class="a" x1="16.5" y1="10" x2="16.5" y2="19.5"/><line class="a" x1="7.5" y1="10" x2="7.5" y2="19.5"/></svg>

app/views/application/_error_messages.html.erb
<% if object.errors.any? %>
  <div id="error_explanation">
    <div class="alert alert-danger">
      The form contains
      <%= pluralize(object.errors.count, "error") %>.
    </div>
    <ul>
      <% object.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
    </ul>
  </div>
<% end %>

app/views/application/_friend_buttons.html.erb
<% unless user == current_user %>
<div class="friend-status">
  <% if current_user.friend?(user) %>
    <%= render 'friend_status_friends', user: user %>
  <% elsif current_user.sent_request?(user) %>
    <%= render 'friend_status_sent', user: user %>
  <% elsif current_user.pending_request?(user) %>
    <%= render 'friend_status_pending', user: user %>
  <% else %>
    <%= render 'friend_status_new', user: user %>
  <% end %>
</div>
<% end %>

app/views/application/_friend_status_friends.html.erb
<p class="status">You are Friends with
  <%= user.name %>
</p>

<% friendship = current_user.friendships.find_by(friend_id: user.id) %>
  <%= form_for friendship, html: { method: :delete } do |f| %>
  <%= f.submit "Unfriend", class: "btn btn-danger" %>
<% end %>

app/views/application/_friend_status_new.html.erb
<p class="status">
  Not Friends with
  <%= user.name %>
</p>

<%= form_for(Friendship.new) do |f| %>
<%= f.hidden_field :friend_id, value: user.id %>
<%= f.submit 'Send Friend Request', class: "btn btn-primary" %>
<% end %>

app/views/application/_friend_status_pending.html.erb
<p class="status"><%= user.name %>
  sent you a friend request!
</p>

<% friendship = current_user.pending_requests.find_by(user_id: user.id) %>

  <div class="pending-request">
    <div class="accept">
      <%= form_for friendship do |f| %>
      <%= f.submit "Accept Friend Request", class: "btn btn-primary" %>
    <% end %>
  </div>
  <div class="reject">
    <%= form_for friendship, html: { method: :delete } do |f| %>
    <%= f.submit "Reject Friend Request", class: "btn btn-warning" %>
  <% end %>
</div>
</div>

app/views/application/_friend_status_sent.html.erb
<p class="status">Friend Request Sent to
  <%= user.name %>
</p>
<% friendship = current_user.sent_requests.find_by(friend_id: user.id) %>
  <%= form_for friendship, html: { method: :delete } do |f| %>
  <%= f.submit 'Cancel Friend Request', class: "btn btn-warning" %>
<% end %>

app/views/application/_friends_container.html.erb
<li class="list_item">
  <%= link_to(gravatar_for(user, 80), user_path(user)) %>
  <%= link_to user.name, user %>
</li>

app/views/application/_guest_home.html.erb
<main class="guest-page">

  <section class="page-info">
    <h1>
      Connect with friends and the<br>world around you on Facebook.
    </h1>

    <div class="part">
      <div class="img-wrapper"><img class="img" src="https://web.archive.org/web/20140312172235im_/https://fbcdn-dragon-a.akamaihd.net/hphotos-ak-ash3/t39.2365/851565_602269956474188_918638970_n.png" alt=""></div>
      <div>
        <strong>
          See photos and updates
        </strong>
        <span>
          from friends in News Feed.
        </span>
      </div>
    </div>

    <div class="part">
      <div class="img-wrapper"><img class="img" src="https://web.archive.org/web/20140312172235im_/https://fbcdn-dragon-a.akamaihd.net/hphotos-ak-ash3/t39.2365/851585_216271631855613_2121533625_n.png" alt=""></div>
      <div>
        <strong>
          Share what's new
        </strong>
        <span>
          in your life on your Timeline.
        </span>
      </div>
    </div>

    <div class="part">
      <div class="img-wrapper"><img class="img" src="https://web.archive.org/web/20140312172235im_/https://fbcdn-dragon-a.akamaihd.net/hphotos-ak-ash3/t39.2365/851558_160351450817973_1678868765_n.png" alt=""></div>
      <div>
        <strong>
          Find more
        </strong>
        <span>
          of what you're looking for with Graph Search.
        </span>
      </div>
    </div>

  </section>

  <section class="sign-up">
    <h1>Sign Up</h1>

    <h2>It’s free and always will be.</h2>

    <%= form_for(:user, url: registration_path(:user)) do |f| %>
    <%= render "devise/shared/error_messages", resource: resource %>
    <div class="field">
      <div class="first-name">
        <%= f.text_field :name, autofocus: true, autocomplete: "name", id: "new_user_name", placeholder: "First Name" %>
      </div>
    </div>

    <div class="field">
      <%= f.email_field :email, autofocus: true, autocomplete: "email", id: "new_user_email", placeholder: "Your Email" %>
    </div>

    <div class="field">
      <%= f.password_field :password, autocomplete: "new-password", id: "new_user_password", placeholder: "New Password" %>
    </div>

    <div class="field">
      <%= f.password_field :password_confirmation, autocomplete: "new-password", id: "new_user_password_confirmation", placeholder: "Re-enter Your Password" %>
    </div>

    <div class="actions">
      <%= f.submit "Sign up", class: "btn btn-primary" %>

      <%- if devise_mapping.omniauthable? %>
        <%- resource_class.omniauth_providers.each do |provider| %>
          <%= link_to omniauth_authorize_path(resource_name, provider), class: "fb-log-in" do %>
          <span class="logo"></span><span class="text">Log in With Facebook</span>
        <% end %>
      <% end %>
    <% end %>
  </div>
<% end %>

</section>

</main>
<footer></footer>

app/views/application/_like_icon.html.erb
<svg class="svg-like" xmlns="http://www.w3.org/2000/svg" viewbox="0 0 24 24">
  <defs></defs>
  <title>like</title><path
    class="a"
    d="M20,15.659h0a1.5,1.5,0,1,1,0,3H19a1.5,1.5,0,0,1,1.5,1.5c0,.829-.672,1-1.5,1H12.5c-2.851,0-3.5-.5-7-1v-8.5c2.45,0,6.5-4.5,6.5-8.5,0-1.581,2.189-2.17,3,.719.5,1.781-1,5.281-1,5.281h8a1.5,1.5,0,0,1,1.5,1.5c0,.829-.672,2-1.5,2H21a1.5,1.5,0,0,1,0,3H20"/><rect class="a" x="0.5" y="10.159" width="5" height="12"/><path d="M3.25,19.159a.75.75,0,1,0,.75.75.75.75,0,0,0-.75-.75Z"/></svg>

app/views/application/_like_unlike.html.erb
<div class="like-wrapper">
  <% if current_user.liked?(post.id) %>
    <%= render 'unlike_form', post: post %>
  <% else %>
    <%= render 'like_form', post: post %>
  <% end %>
</div>

app/views/application/_unlike_form.html.erb
<%= form_for current_user.likes_given.find_by(post_id: post.id), 
             html: { method: :delete } do |f| %>
<div><%= hidden_field_tag :post_id, post.id %></div>
  <%= f.button name: "unlike-button"  do %>
    <%= render 'like_icon' %> 
  <% end %>
<% end %>

app/views/application/_user_card.html.erb
<div class="user-card">
<%= @user.name %>
<%= render 'friend_form' %>
</div>